diff --git a/content/common/sandbox_linux/bpf_media_policy_linux.cc b/content/common/sandbox_linux/bpf_media_policy_linux.cc
new file mode 100644
index 0000000..67f7b25
--- /dev/null
+++ b/content/common/sandbox_linux/bpf_media_policy_linux.cc
@@ -0,0 +1,535 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/common/sandbox_linux/bpf_media_policy_linux.h"
+
+#include <dlfcn.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <sys/socket.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+#include <string>
+#include <vector>
+
+#include "base/bind.h"
+#include "base/command_line.h"
+#include "base/compiler_specific.h"
+#include "base/logging.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/strings/string_split.h"
+#include "build/build_config.h"
+#include "content/common/sandbox_linux/sandbox_bpf_base_policy_linux.h"
+#include "content/common/sandbox_linux/sandbox_seccomp_bpf_linux.h"
+#include "content/common/set_process_title.h"
+#include "content/public/common/content_switches.h"
+#include "sandbox/linux/bpf_dsl/bpf_dsl.h"
+#include "sandbox/linux/bpf_dsl/bpf_dsl_impl.h"
+#include "sandbox/linux/bpf_dsl/policy_compiler.h"
+#include "sandbox/linux/seccomp-bpf/die.h"
+#include "sandbox/linux/seccomp-bpf/errorcode.h"
+#include "sandbox/linux/seccomp-bpf/sandbox_bpf.h"
+#include "sandbox/linux/seccomp-bpf/syscall.h"
+#include "sandbox/linux/seccomp-bpf-helpers/sigsys_handlers.h"
+#include "sandbox/linux/seccomp-bpf-helpers/syscall_parameters_restrictions.h"
+#include "sandbox/linux/seccomp-bpf-helpers/syscall_sets.h"
+#include "sandbox/linux/syscall_broker/broker_file_permission.h"
+#include "sandbox/linux/syscall_broker/broker_process.h"
+#include "sandbox/linux/system_headers/linux_syscalls.h"
+
+using sandbox::arch_seccomp_data;
+using sandbox::bpf_dsl::Allow;
+using sandbox::bpf_dsl::Error;
+using sandbox::bpf_dsl::Arg;
+using sandbox::bpf_dsl::If;
+using sandbox::bpf_dsl::ResultExpr;
+using sandbox::bpf_dsl::Trap;
+using sandbox::bpf_dsl::UnsafeTrap;
+using sandbox::syscall_broker::BrokerFilePermission;
+using sandbox::syscall_broker::BrokerProcess;
+using sandbox::SyscallSets;
+
+namespace content {
+
+namespace {
+
+intptr_t MediaSIGSYS_Handler(const struct arch_seccomp_data& args,
+                             void* aux_broker_process) {
+  RAW_CHECK(aux_broker_process);
+  BrokerProcess* broker_process =
+      static_cast<BrokerProcess*>(aux_broker_process);
+
+  // For debuging purposes:
+  // It is possible to do the system call in this handler (instead of doing
+  // it in the broker process) by just uncommenting the following line:
+  // return sandbox::SandboxBPF::ForwardSyscall(args);
+
+  switch (args.nr) {
+#if !defined(__aarch64__)
+    case __NR_access: {
+      intptr_t retv =
+          broker_process->Access(reinterpret_cast<const char*>(args.args[0]),
+                                 static_cast<int>(args.args[1]));
+      if (retv < 1) {
+        struct stat sb;
+        if (!stat(reinterpret_cast<const char*>(args.args[0]), &sb)) {
+          VLOG(1) << "access failed: "
+                  << reinterpret_cast<const char*>(args.args[0])
+                  << static_cast<int>(args.args[1]);
+        }
+      }
+      return retv;
+    }
+    case __NR_open:
+#if defined(MEMORY_SANITIZER)
+      // http://crbug.com/372840
+      __msan_unpoison_string(reinterpret_cast<const char*>(args.args[0]));
+#endif
+      {
+        intptr_t retv =
+            broker_process->Open(reinterpret_cast<const char*>(args.args[0]),
+                                 static_cast<int>(args.args[1]));
+        if (retv < 1) {
+          struct stat sb;
+          if (!stat(reinterpret_cast<const char*>(args.args[0]), &sb)) {
+            VLOG(1) << "open failed: "
+                    << reinterpret_cast<const char*>(args.args[0]);
+          }
+        }
+        return retv;
+      }
+#endif  // !defined(__aarch64__)
+    case __NR_faccessat:
+      if (static_cast<int>(args.args[0]) == AT_FDCWD) {
+        intptr_t retv =
+            broker_process->Access(reinterpret_cast<const char*>(args.args[1]),
+                                   static_cast<int>(args.args[2]));
+        if (retv < 1) {
+          struct stat sb;
+          if (!stat(reinterpret_cast<const char*>(args.args[1]), &sb)) {
+            VLOG(1) << "faccessat failed: "
+                    << reinterpret_cast<const char*>(args.args[1]);
+          }
+        }
+        return retv;
+      } else {
+        return -EPERM;
+      }
+    case __NR_openat:
+      // Allow using openat() as open().
+      if (static_cast<int>(args.args[0]) == AT_FDCWD) {
+        intptr_t retv =
+            broker_process->Open(reinterpret_cast<const char*>(args.args[1]),
+                                 static_cast<int>(args.args[2]));
+        if (retv < 1) {
+          struct stat sb;
+          if (!stat(reinterpret_cast<const char*>(args.args[1]), &sb)) {
+            VLOG(1) << "openat failed: "
+                    << reinterpret_cast<const char*>(args.args[1]);
+          }
+        }
+        return retv;
+      } else {
+        return -EPERM;
+      }
+    default:
+      RAW_CHECK(false);
+      return -ENOSYS;
+  }
+}
+
+class MediaBrokerProcessPolicy : public MediaProcessPolicy {
+ public:
+  static sandbox::bpf_dsl::Policy* Create() {
+    return new MediaBrokerProcessPolicy();
+  }
+  ~MediaBrokerProcessPolicy() override {}
+
+  ResultExpr EvaluateSyscall(int system_call_number) const override;
+
+ private:
+  MediaBrokerProcessPolicy() {}
+  DISALLOW_COPY_AND_ASSIGN(MediaBrokerProcessPolicy);
+};
+
+// x86_64/i386 or desktop ARM.
+ResultExpr MediaBrokerProcessPolicy::EvaluateSyscall(int sysno) const {
+  switch (sysno) {
+#if !defined(__aarch64__)
+    case __NR_access:
+    case __NR_open:
+#endif  // !defined(__aarch64__)
+    case __NR_faccessat:
+    case __NR_openat:
+    // The broker process needs to able to unlink the temporary
+    // files that it may create.
+    case __NR_unlink:
+      return Allow();
+    default:
+      return MediaProcessPolicy::EvaluateSyscall(sysno);
+  }
+}
+
+void UpdateProcessTypeToMediaBroker() {
+  base::CommandLine::StringVector exec =
+      base::CommandLine::ForCurrentProcess()->GetArgs();
+  base::CommandLine::Reset();
+  base::CommandLine::Init(0, NULL);
+  base::CommandLine::ForCurrentProcess()->InitFromArgv(exec);
+  base::CommandLine::ForCurrentProcess()->AppendSwitchASCII(
+      switches::kProcessType, "media-broker");
+
+  // Update the process title. The argv was already cached by the call to
+  // SetProcessTitleFromCommandLine in content_main_runner.cc, so we can pass
+  // NULL here (we don't have the original argv at this point).
+  SetProcessTitleFromCommandLine(NULL);
+}
+
+bool UpdateProcessTypeAndEnableSandbox(
+    sandbox::bpf_dsl::Policy* (*broker_sandboxer_allocator)(void)) {
+  DCHECK(broker_sandboxer_allocator);
+  UpdateProcessTypeToMediaBroker();
+  return SandboxSeccompBPF::StartSandboxWithExternalPolicy(
+      make_scoped_ptr(broker_sandboxer_allocator()), base::ScopedFD());
+}
+
+}  // namespace
+
+MediaProcessPolicy::MediaProcessPolicy() : broker_process_(NULL) {}
+
+MediaProcessPolicy::~MediaProcessPolicy() {}
+
+// Main policy for x86_64/i386.
+ResultExpr MediaProcessPolicy::EvaluateSyscall(int sysno) const {
+  // Uncomment next lines to enable UnsafeTrap below:
+  // if (sandbox::SandboxBPF::IsRequiredForUnsafeTrap(sysno))
+  //   return Allow();
+
+  switch (sysno) {
+#if !defined(NDEBUG)
+    // TODO: check if this is really necessary for frame steping with gdb.
+    case __NR_pause:
+      return Allow();
+#endif
+
+    case __NR_clock_getres:
+    // Allow the system calls below.
+    case __NR_fdatasync:
+#if defined(__i386__) || defined(__x86_64__) || defined(__mips__)
+    case __NR_getrlimit:
+#endif
+#if defined(__i386__) || defined(__arm__)
+    case __NR_ugetrlimit:
+#endif
+    case __NR_mremap:  // See crbug.com/149834.
+    case __NR_pread64:
+    case __NR_pwrite64:
+    case __NR_sched_get_priority_max:
+    case __NR_sched_get_priority_min:
+    case __NR_sysinfo:
+    case __NR_times:
+      return Allow();
+
+#if !defined(OS_CHROMEOS)
+    case __NR_ftruncate:
+#endif
+    case __NR_fsync:
+#if !defined(__aarch64__)
+    // TODO: investigate who is using it in order to remove it.
+    case __NR_getdents:  // EPERM not a valid errno.
+#endif
+    case __NR_getdents64:  // EPERM not a valid errno.
+    case __NR_futex:
+    case __NR_ioctl:
+#if defined(__i386__) || defined(__x86_64__) || defined(__mips__)
+    // The Nvidia driver uses flags not in the baseline policy
+    // (MAP_LOCKED | MAP_EXECUTABLE | MAP_32BIT)
+    case __NR_mmap:
+#endif
+    // We also hit this on the linux_chromeos bot but don't yet know what
+    // weird flags were involved.
+    case __NR_mprotect:
+#if defined(__i386__) || defined(__arm__) || defined(__mips__)
+    case __NR_stat64:
+    case __NR_statfs64:
+#endif
+    case __NR_stat:
+    case __NR_statfs:  // Required for shm_open.
+    case __NR_unlink:
+    case __NR_uname:
+      return Allow();
+
+    // Pulse audio, see pulsecore/core-utils.c::pa_make_secure_dir
+    case __NR_fchown:
+#if defined(__i386__) || defined(__arm__)
+    case __NR_fchown32:
+#endif
+    case __NR_lstat:
+    case __NR_mkdir:
+      return Allow();
+
+// SECCOMP_RET_TRAP:
+// Send a catchable SIGSYS, giving a chance to emulate the
+// syscall. Emulation is done in the media broker process.
+#if !defined(__aarch64__)
+    case __NR_access:
+    case __NR_open:
+#endif  // !defined(__aarch64__)
+    case __NR_faccessat:
+    case __NR_openat: {
+      DCHECK(broker_process_);
+      return Trap(MediaSIGSYS_Handler, broker_process_);
+
+      // For debuging purposes in order to use SandboxBPF::ForwardSyscall
+      // in MediaSIGSYS_Handler you need to set CHROME_SANDBOX_DEBUGGING=1
+      // and uncomment the following line:
+      // return UnsafeTrap(MediaSIGSYS_Handler, broker_process_);
+    }
+
+    // Other cases:
+    default:
+      if (SyscallSets::IsEventFd(sysno))
+        return Allow();
+
+      if (SyscallSets::IsUmask(sysno) ||
+          SyscallSets::IsDeniedFileSystemAccessViaFd(sysno)) {
+        return Error(EPERM);
+      }
+
+      // Debug
+      if (SyscallSets::IsDebug(sysno))
+        return Error(EPERM);
+
+      // Kernel
+      if (SyscallSets::IsKernelInternalApi(sysno) ||
+          SyscallSets::IsKernelModule(sysno))
+        return Error(EPERM);
+
+      // System
+      if (SyscallSets::IsAdminOperation(sysno) ||
+          SyscallSets::IsAnySystemV(sysno) ||
+          SyscallSets::IsGlobalFSViewChange(sysno))
+        return Error(EPERM);
+
+      // Seccomp
+      if (SyscallSets::IsSeccomp(sysno))
+        return Error(EPERM);
+
+// Network: (duplicate of SandboxBPFBasePolicy::EvaluateSyscall)
+#if defined(__x86_64__)
+      if (sysno == __NR_socketpair) {
+        // Only allow AF_UNIX, PF_UNIX. Crash if anything else is seen.
+        static_assert(AF_UNIX == PF_UNIX,
+                      "af_unix and pf_unix should not be different");
+        const Arg<int> domain(0);
+        return If(domain == AF_UNIX, Allow()).Else(sandbox::CrashSIGSYS());
+      }
+
+      // Pulseaudio, see socket-client.c::do_call
+      if (sysno == __NR_getsockopt) {
+        const Arg<int> level(1);
+        return If(level == SOL_SOCKET, Allow()).Else(sandbox::CrashSIGSYS());
+      }
+
+      // Pulseaudio, see client-conf-x11::xcb_connect
+      switch (sysno) {
+#if defined(__x86_64__) || defined(__arm__) || defined(__mips__) || \
+    defined(__aarch64__)
+        case __NR_connect:
+          return Allow();
+        case __NR_socket:
+          const Arg<int> domain(0), type(1);
+          return If(domain == AF_UNIX && type == (SOCK_STREAM | SOCK_CLOEXEC), Allow())
+              .Else(Error(EPERM));
+      }
+#endif
+
+      if (SyscallSets::IsNetworkSocketInformation(sysno) ||
+          SyscallSets::IsDeniedGetOrModifySocket(sysno)) {
+        return Error(EPERM);
+      }
+#endif
+
+      // Process
+      if (SyscallSets::IsCurrentDirectory(sysno) ||
+          SyscallSets::IsFileSystem(sysno) ||
+          SyscallSets::IsAllowedProcessStartOrDeath(sysno) ||
+          SyscallSets::IsProcessGroupOrSession(sysno) ||
+          SyscallSets::IsProcessPrivilegeChange(sysno))
+        return Error(EPERM);
+
+      return SandboxBPFBasePolicy::EvaluateSyscall(sysno);
+  }
+}
+
+bool MediaProcessPolicy::PreSandboxHook() {
+  // Warm up resources needed by the policy we're about to enable and
+  // eventually start a broker process.
+
+  DCHECK(!broker_process());
+  // Create a new broker process.
+  InitMediaBrokerProcess(
+      MediaBrokerProcessPolicy::Create,
+      std::vector<BrokerFilePermission>());  // No extra files in whitelist.
+  return true;
+}
+
+static void splitAndAddReadOnlyPermission(const char* path,
+    const std::string& delimiter,
+    std::vector<BrokerFilePermission>& permissions)
+{
+  if (path) {
+    std::vector<std::string> results;
+    base::SplitStringUsingSubstr(path, delimiter, &results);
+    for (auto it = results.begin(); it != results.end(); ++it) {
+      if (!it->empty()) {
+        if (*(it->rbegin()) != '/') {
+          permissions.push_back(
+              BrokerFilePermission::ReadOnly(*it));
+          it->append("/");
+        }
+        permissions.push_back(
+            BrokerFilePermission::ReadOnlyRecursive(*it));
+      }
+    }
+  }
+}
+
+void MediaProcessPolicy::InitMediaBrokerProcess(
+    sandbox::bpf_dsl::Policy* (*broker_sandboxer_allocator)(void),
+    const std::vector<BrokerFilePermission>& permissions_extra) {
+  CHECK(broker_process_ == NULL);
+
+// dev folders
+#if !defined(NDEBUG)
+  // Core dumps. Can be chromium/src too. Use ulimit -c unlimited.
+  static const char kVarCrashPath[] = "/var/crash/";
+#endif
+
+#if !defined(OFFICIAL_BUILD)
+  // Gst plugins path
+  static const char* kGstPluginPath = getenv("GST_PLUGIN_PATH");
+  static const char* kGstPluginScanner = getenv("GST_PLUGIN_SCANNER");
+  static const char* kGstRegistry = getenv("GST_REGISTRY");
+  static const char* kLdLibraryPath = getenv("LD_LIBRARY_PATH");
+#endif
+
+  // Pulse audio.
+  static const char kDevShmPath[] = "/dev/shm/";
+  static const char kUsrLibPulseModulesPath[] = "/usr/lib/pulse-4.0/modules/";
+  static const char kEtcPulsePath[] = "/etc/pulse/";
+  const std::string kDevRunUserPulse =
+      std::string(getenv("XDG_RUNTIME_DIR")) + "/pulse";
+  const std::string kDevRunUserPulsePath =
+      std::string(getenv("XDG_RUNTIME_DIR")) + "/pulse/";
+  const std::string kHomePulsePath =
+      std::string(getenv("HOME")) + "/.pulse/";
+  const std::string kHomeConfigPulsePath =
+      std::string(getenv("HOME")) + "/.config/pulse/";
+  const std::string kHomeXauth =
+      std::string(getenv("HOME")) + "/.Xauthority";
+
+  // GStreamer registry:
+  // TODO: Implement more fine grained approach
+  const std::string kHomeCacheGstreamerPath =
+      std::string(getenv("HOME")) + "/.cache/gstreamer-1.0/";
+  const std::string kHomeCacheGstreamerRegistry =
+      std::string(getenv("HOME")) + "/.cache/gstreamer-1.0/registry.x86_64.bin";
+
+  // Shared libraries.
+  // TODO: Implement more fine grained approach to only allow
+  // required gstreamer plugins and its deps.
+  static const char kDevLibPath[] = "/lib/";
+  static const char kDevLib64Path[] = "/lib64/";
+  static const char kDevUSRLib32Path[] = "/usr/lib32/";
+  static const char kDevUSRLib64Path[] = "/usr/lib64/";
+  static const char kDevUSRLocalLib32Path[] = "/usr/local/lib32/";
+  static const char kDevUSRLocalLib64Path[] = "/usr/local/lib64/";
+  static const char kDevUSRLibPath[] = "/usr/lib/";
+  static const char kDevUSRLocalLibPath[] = "/usr/local/lib/";
+
+  // TODO: check if these are required.
+  static const char kLDCachePath[] = "/etc/ld.so.cache";
+  static const char kDevUSRSharePath[] = "/usr/share/";
+  static const char kDevUSRLocalSharePath[] = "/usr/local/share/";
+  static const char kVarLibDBUSMachineID[] = "/var/lib/dbus/machine-id";
+
+  std::vector<BrokerFilePermission> permissions;
+
+#if !defined(NDEBUG)
+  permissions.push_back(
+      BrokerFilePermission::ReadWriteCreateRecursive(kVarCrashPath));
+#endif
+
+#if !defined(OFFICIAL_BUILD)
+  if (kGstRegistry)
+    permissions.push_back(
+        BrokerFilePermission::ReadOnly(kGstRegistry));
+
+  splitAndAddReadOnlyPermission(kGstPluginPath, ":", permissions);
+  splitAndAddReadOnlyPermission(kLdLibraryPath, ":", permissions);
+  splitAndAddReadOnlyPermission(kGstPluginScanner, ":", permissions);
+#endif
+
+  // Pulse audio
+  permissions.push_back(
+      BrokerFilePermission::ReadWriteCreateRecursive(kDevShmPath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kUsrLibPulseModulesPath));
+  permissions.push_back(BrokerFilePermission::ReadOnlyRecursive(kEtcPulsePath));
+  permissions.push_back(BrokerFilePermission::ReadWriteCreateUnlinkRecursive(
+      kDevRunUserPulsePath));
+  permissions.push_back(
+      BrokerFilePermission::ReadWriteCreate(kDevRunUserPulse));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kHomePulsePath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kHomeConfigPulsePath));
+  permissions.push_back(BrokerFilePermission::ReadOnly(kHomeXauth));
+
+  // GStreamer registry
+  permissions.push_back(BrokerFilePermission::ReadWriteCreateUnlinkRecursive(
+      kHomeCacheGstreamerPath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnly(kHomeCacheGstreamerRegistry));
+
+  // Shared libraries.
+  permissions.push_back(BrokerFilePermission::ReadOnlyRecursive(kDevLibPath));
+  permissions.push_back(BrokerFilePermission::ReadOnlyRecursive(kDevLib64Path));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLib32Path));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLib64Path));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLocalLib32Path));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLocalLib64Path));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLibPath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLocalLibPath));
+
+  // TODO: check if this is required.
+  permissions.push_back(BrokerFilePermission::ReadOnly(kLDCachePath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRSharePath));
+  permissions.push_back(
+      BrokerFilePermission::ReadOnlyRecursive(kDevUSRLocalSharePath));
+  permissions.push_back(BrokerFilePermission::ReadOnly(kVarLibDBUSMachineID));
+
+  // Add eventual extra files from permissions_extra.
+  for (const auto& perm : permissions_extra) {
+    permissions.push_back(perm);
+  }
+
+  broker_process_ = new BrokerProcess(GetFSDeniedErrno(), permissions);
+  // The initialization callback will perform generic initialization and then
+  // call broker_sandboxer_callback.
+  CHECK(broker_process_->Init(base::Bind(&UpdateProcessTypeAndEnableSandbox,
+                                         broker_sandboxer_allocator)));
+}
+
+}  // namespace content
diff --git a/content/common/sandbox_linux/bpf_media_policy_linux.h b/content/common/sandbox_linux/bpf_media_policy_linux.h
new file mode 100644
index 0000000..175addc
--- /dev/null
+++ b/content/common/sandbox_linux/bpf_media_policy_linux.h
@@ -0,0 +1,64 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_SANDBOX_LINUX_BPF_MEDIA_POLICY_LINUX_H_
+#define CONTENT_COMMON_SANDBOX_LINUX_BPF_MEDIA_POLICY_LINUX_H_
+
+#include <string>
+#include <vector>
+
+#include "base/callback_forward.h"
+#include "content/common/sandbox_linux/sandbox_bpf_base_policy_linux.h"
+
+namespace sandbox {
+namespace syscall_broker {
+class BrokerFilePermission;
+class BrokerProcess;
+}
+}
+
+namespace content {
+
+class MediaProcessPolicy : public SandboxBPFBasePolicy {
+ public:
+  MediaProcessPolicy();
+  ~MediaProcessPolicy() override;
+
+  sandbox::bpf_dsl::ResultExpr EvaluateSyscall(
+      int system_call_number) const override;
+
+  bool PreSandboxHook() override;
+
+ protected:
+  // Start a broker process to handle open() inside the sandbox.
+  // |broker_sandboxer_allocator| is a function pointer which can allocate a
+  // suitable sandbox policy for the broker process itself.
+  // |permissions_extra| is a list of file permissions
+  // that should be whitelisted by the broker process, in addition to
+  // the basic ones.
+  void InitMediaBrokerProcess(
+      sandbox::bpf_dsl::Policy* (*broker_sandboxer_allocator)(void),
+      const std::vector<sandbox::syscall_broker::BrokerFilePermission>&
+          permissions_extra);
+
+  sandbox::syscall_broker::BrokerProcess* broker_process() {
+    return broker_process_;
+  }
+
+ private:
+  // A BrokerProcess is a helper that is started before the sandbox is engaged
+  // and will serve requests to access files over an IPC channel. The client of
+  // this runs from a SIGSYS handler triggered by the seccomp-bpf sandbox.
+  // This should never be destroyed, as after the sandbox is started it is
+  // vital to the process.
+  // This is allocated by InitMediaBrokerProcess, called from PreSandboxHook(),
+  // which executes iff the sandbox is going to be enabled afterwards.
+  sandbox::syscall_broker::BrokerProcess* broker_process_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaProcessPolicy);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_COMMON_SANDBOX_LINUX_BPF_GPU_POLICY_LINUX_H_
diff --git a/content/common/sandbox_linux/sandbox_seccomp_bpf_linux.cc b/content/common/sandbox_linux/sandbox_seccomp_bpf_linux.cc
index 79adbee..65075f8 100644
--- a/content/common/sandbox_linux/sandbox_seccomp_bpf_linux.cc
+++ b/content/common/sandbox_linux/sandbox_seccomp_bpf_linux.cc
@@ -24,6 +24,9 @@
 #include "base/posix/eintr_wrapper.h"
 #include "content/common/sandbox_linux/bpf_cros_arm_gpu_policy_linux.h"
 #include "content/common/sandbox_linux/bpf_gpu_policy_linux.h"
+#if defined(USE_GSTREAMER)
+#include "content/common/sandbox_linux/bpf_media_policy_linux.h"
+#endif
 #include "content/common/sandbox_linux/bpf_ppapi_policy_linux.h"
 #include "content/common/sandbox_linux/bpf_renderer_policy_linux.h"
 #include "content/common/sandbox_linux/bpf_utility_policy_linux.h"
@@ -132,6 +135,9 @@ ResultExpr AllowAllPolicy::EvaluateSyscall(int sysno) const {
 void RunSandboxSanityChecks(const std::string& process_type) {
   if (process_type == switches::kRendererProcess ||
       process_type == switches::kGpuProcess ||
+#if defined(USE_GSTREAMER)
+      process_type == switches::kMediaProcess ||
+#endif
       process_type == switches::kPpapiPluginProcess) {
     int syscall_ret;
     errno = 0;
@@ -153,6 +159,7 @@ void RunSandboxSanityChecks(const std::string& process_type) {
     syscall_ret = socket(AF_NETLINK, SOCK_DGRAM, 0);
     CHECK_EQ(-1, syscall_ret);
     CHECK_EQ(EPERM, errno);
+
 #endif  // !defined(NDEBUG)
   }
 }
@@ -195,6 +202,10 @@ bool StartBPFSandbox(const base::CommandLine& command_line,
     policy.reset(new PpapiProcessPolicy);
   } else if (process_type == switches::kUtilityProcess) {
     policy.reset(new UtilityProcessPolicy);
+#if defined(USE_GSTREAMER)
+  } else if (process_type == switches::kMediaProcess) {
+    policy.reset(new MediaProcessPolicy);
+#endif
   } else {
     NOTREACHED();
     policy.reset(new AllowAllPolicy);
@@ -243,6 +254,10 @@ bool SandboxSeccompBPF::ShouldEnableSeccompBPF(
       *base::CommandLine::ForCurrentProcess();
   if (process_type == switches::kGpuProcess)
     return !command_line.HasSwitch(switches::kDisableGpuSandbox);
+#if defined(USE_GSTREAMER)
+  else if (process_type == switches::kMediaProcess)
+    return !command_line.HasSwitch(switches::kDisableMediaSandbox);
+#endif
 
   return true;
 #endif  // USE_SECCOMP_BPF
diff --git a/content/content.gyp b/content/content.gyp
index 41beae7..43fba98 100644
--- a/content/content.gyp
+++ b/content/content.gyp
@@ -76,6 +76,7 @@
               'dependencies': [
                 'content_child',
                 'content_gpu',
+                'content_media',
                 'content_plugin',
                 'content_ppapi_plugin',
                 'content_renderer',
@@ -229,6 +230,19 @@
               ],
             },
             {
+              # GN version: //content/media
+              'target_name': 'content_media',
+              'type': 'static_library',
+              'variables': { 'enable_wexit_time_destructors': 1, },
+              'includes': [
+                'content_media.gypi',
+              ],
+              'dependencies': [
+                'content_child',
+                'content_common',
+              ],
+            },
+            {
               # GN version: //content/plugin and //content/public/plugin
               'target_name': 'content_plugin',
               'type': 'static_library',
@@ -317,6 +331,7 @@
             'content_child.gypi',
             'content_common.gypi',
             'content_gpu.gypi',
+            'content_media.gypi',
             'content_plugin.gypi',
             'content_ppapi_plugin.gypi',
             'content_renderer.gypi',
@@ -380,6 +395,12 @@
           'dependencies': ['content'],
         },
         {
+          # GN version: //content/media
+          'target_name': 'content_media',
+          'type': 'none',
+          'dependencies': ['content'],
+        },
+        {
           # GN version: //content/plugin
           'target_name': 'content_plugin',
           'type': 'none',
diff --git a/content/content_browser.gypi b/content/content_browser.gypi
index d2888f8..31ba808 100644
--- a/content/content_browser.gypi
+++ b/content/content_browser.gypi
@@ -1809,6 +1809,22 @@
         '../third_party/mojo/mojo_public.gyp:mojo_cpp_bindings',
       ],
     }],
+    ['use_gstreamer==1', {
+      'sources': [
+        'public/browser/media_data_manager.h',
+        'public/browser/media_data_manager_observer.h',
+        'browser/media/media_data_manager_impl.cc',
+        'browser/media/media_data_manager_impl.h',
+        'browser/media/media_data_manager_impl_private.cc',
+        'browser/media/media_data_manager_impl_private.h',
+        'browser/media/media_process_host.cc',
+        'browser/media/media_process_host.h',
+        'browser/media/media_process_host_ui_shim.cc',
+        'browser/media/media_process_host_ui_shim.h',
+        'browser/renderer_host/media_message_filter.cc',
+        'browser/renderer_host/media_message_filter.h',
+      ]
+    }],
     ['debug_devtools==1', {
       'defines': [
         'DEBUG_DEVTOOLS=1',
diff --git a/content/content_common.gypi b/content/content_common.gypi
index 57c6a5d..8532d5e 100644
--- a/content/content_common.gypi
+++ b/content/content_common.gypi
@@ -192,6 +192,7 @@
       'common/cache_storage/cache_storage_types.h',
       'common/cc_messages.cc',
       'common/cc_messages.h',
+      'common/channel_host_thread.h',
       'common/child_process_host_impl.cc',
       'common/child_process_host_impl.h',
       'common/child_process_messages.h',
@@ -424,6 +425,17 @@
       'common/media/audio_messages.h',
       'common/media/cdm_messages.h',
       'common/media/cdm_messages_enums.h',
+      'common/media/media_channel.cc',
+      'common/media/media_channel.h',
+      'common/media/media_channel_filter.cc',
+      'common/media/media_channel_filter.h',
+      'common/media/media_channel_host.cc',
+      'common/media/media_channel_host.h',
+      'common/media/media_config.h',
+      'common/media/media_messages.h',
+      'common/media/media_player_messages_gstreamer.h',
+      'common/media/media_player_messages_enums_gstreamer.h',
+      'common/media/media_process_launch_causes.h',
       'common/media/media_param_traits.cc',
       'common/media/media_param_traits.h',
       'common/media/media_player_messages_android.h',
@@ -492,6 +504,8 @@
       'common/sandbox_linux/bpf_cros_arm_gpu_policy_linux.h',
       'common/sandbox_linux/bpf_gpu_policy_linux.cc',
       'common/sandbox_linux/bpf_gpu_policy_linux.h',
+      'common/sandbox_linux/bpf_media_policy_linux.cc',
+      'common/sandbox_linux/bpf_media_policy_linux.h',
       'common/sandbox_linux/bpf_ppapi_policy_linux.cc',
       'common/sandbox_linux/bpf_ppapi_policy_linux.h',
       'common/sandbox_linux/bpf_renderer_policy_linux.cc',
@@ -797,6 +811,25 @@
         '../third_party/libjingle/libjingle.gyp:libjingle',
       ],
     }],
+    ['use_gstreamer==0', {
+      'sources!': [
+        'common/channel_host_thread.h',
+        'common/gpu/media/android_video_decode_accelerator.h',
+        'common/media/media_channel.cc',
+        'common/media/media_channel.h',
+        'common/media/media_channel_filter.cc',
+        'common/media/media_channel_filter.h',
+        'common/media/media_channel_host.cc',
+        'common/media/media_channel_host.h',
+        'common/media/media_config.h',
+        'common/media/media_messages.h',
+        'common/media/media_player_messages_gstreamer.h',
+        'common/media/media_player_messages_enums_gstreamer.h',
+        'common/media/media_process_launch_causes.h',
+        'common/sandbox_linux/bpf_media_policy_linux.cc',
+        'common/sandbox_linux/bpf_media_policy_linux.h',
+      ],
+    }],
     ['use_v4lplugin==1 and chromeos==1', {
       'defines': [
         'USE_LIBV4L2'
diff --git a/content/content_media.gypi b/content/content_media.gypi
new file mode 100644
index 0000000..043ee7f
--- /dev/null
+++ b/content/content_media.gypi
@@ -0,0 +1,44 @@
+# Copyright (c) 2015 The Chromium Authors. All rights reserved.
+# Use of this source code is governed by a BSD-style license that can be
+# found in the LICENSE file.
+
+{
+  'conditions': [
+    ['use_gstreamer==1', {
+      'dependencies': [
+        '../base/base.gyp:base',
+        '../build/linux/system.gyp:gstreamer',
+      ],
+      'sources': [
+        'media/in_process_media_thread.cc',
+        'media/in_process_media_thread.h',
+        'media/media_child_thread.cc',
+        'media/media_child_thread.h',
+        'media/media_main.cc',
+        'media/media_process.cc',
+        'media/media_process.h',
+        'media/gstreamer/gpuprocess/client_egl.h',
+        'media/gstreamer/gpuprocess/client_egl.cc',
+        'media/gstreamer/gpuprocess/gstglcontext_gpu_process.c',
+        'media/gstreamer/gpuprocess/gstglcontext_gpu_process.h',
+        'media/gstreamer/gpuprocess/gstgldisplay_gpu_process.c',
+        'media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h',
+        'media/gstreamer/gpuprocess/gstglwindow_gpu_process.c',
+        'media/gstreamer/gpuprocess/gstglwindow_gpu_process.h',
+        'media/gstreamer/gst_chromium_http_source.cc',
+        'media/gstreamer/gst_chromium_http_source.h',
+        'media/gstreamer/gst_chromium_media_src.cc',
+        'media/gstreamer/gst_chromium_media_src.h',
+        'media/gstreamer/gst_chromium_aes_ctr.cc',
+        'media/gstreamer/gst_chromium_aes_ctr.h',
+        'media/gstreamer/gst_chromium_common_encryption_decryptor.cc',
+        'media/gstreamer/gst_chromium_common_encryption_decryptor.h',
+        'media/gstreamer/media_player_gstreamer.cc',
+        'media/gstreamer/media_player_gstreamer.h',
+      ],
+      'include_dirs': [
+        '..',
+      ],
+    }],
+  ],
+}
